// CRadioListBoxTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CRadioListBoxTest.h"
#include "CRadioListBoxTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCRadioListBoxTestDlg dialog

CCRadioListBoxTestDlg::CCRadioListBoxTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCRadioListBoxTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCRadioListBoxTestDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCRadioListBoxTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCRadioListBoxTestDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCRadioListBoxTestDlg, CDialog)
	//{{AFX_MSG_MAP(CCRadioListBoxTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_LBN_SELCHANGE(IDC_RADIOLISTBOX, OnSelChange)
	ON_BN_CLICKED(ID_SET1, OnSet1)
	ON_BN_CLICKED(ID_SET2, OnSet2)
	ON_BN_CLICKED(ID_SET3, OnSet3)
	ON_BN_CLICKED(IDC_CHECK1, OnTransparent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCRadioListBoxTestDlg message handlers

BOOL CCRadioListBoxTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

//	OnSet1();

	///////////////////////////////////////////////////
	// HERE YOU HAVE TO SUBCLASS THE LISTBOX CONTROL //
	///////////////////////////////////////////////////

	m_RadioListBox.SubclassDlgItem(IDC_RADIOLISTBOX, this);   
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCRadioListBoxTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCRadioListBoxTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CCRadioListBoxTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Updates the static text every time a selection in listbox changes
void CCRadioListBoxTestDlg::OnSelChange() 
{
	CString text;
	text.Format("Index: %i", m_RadioListBox.GetCurSel());

	SetDlgItemText(IDC_STATICTEXT, text);
}

void CCRadioListBoxTestDlg::OnSet1() 
{
	m_RadioListBox.ResetContent();   // Clear all contents

	m_RadioListBox.InsertString(0, "Uno");
	m_RadioListBox.InsertString(1, "Dos");
	m_RadioListBox.InsertString(2, "Tres");
	m_RadioListBox.InsertString(3, "Cuatro");
	m_RadioListBox.InsertString(4, "Cinco");
	m_RadioListBox.InsertString(5, "Seis");
	m_RadioListBox.InsertString(6, "Siete");
	m_RadioListBox.InsertString(7, "Ocho");
	m_RadioListBox.InsertString(8, "Nueve");
	m_RadioListBox.InsertString(9, "Diez");

	OnSelChange();   // Updates static text
}

void CCRadioListBoxTestDlg::OnSet2() 
{
	m_RadioListBox.ResetContent();   // Clear all contents

	m_RadioListBox.InsertString(0, "One");
	m_RadioListBox.InsertString(1, "Two");
	m_RadioListBox.InsertString(2, "Three");
	m_RadioListBox.InsertString(3, "Four");
	m_RadioListBox.InsertString(4, "Five");
	m_RadioListBox.InsertString(5, "Six");
	m_RadioListBox.InsertString(6, "Seven");
	m_RadioListBox.InsertString(7, "Eight");
	m_RadioListBox.InsertString(8, "Nine");
	m_RadioListBox.InsertString(9, "Ten");
	m_RadioListBox.InsertString(10, "Eleven");
	m_RadioListBox.InsertString(11, "Twelve");

	OnSelChange();   // Updates static text
}

void CCRadioListBoxTestDlg::OnSet3() 
{
	m_RadioListBox.ResetContent();   // Clear all contents

	m_RadioListBox.InsertString(0, "Ein");
	m_RadioListBox.InsertString(1, "Zwei");
	m_RadioListBox.InsertString(2, "Drei");
	m_RadioListBox.InsertString(3, "Vier");
	m_RadioListBox.InsertString(4, "Fnf");
	m_RadioListBox.InsertString(5, "Sechs");
	m_RadioListBox.InsertString(6, "Sieben");
	m_RadioListBox.InsertString(7, "Acht");
	m_RadioListBox.InsertString(8, "Neun");
	m_RadioListBox.InsertString(9, "Zen");

	OnSelChange();   // Updates static text
}

void CCRadioListBoxTestDlg::OnTransparent() 
{
	if ( ((CButton *)GetDlgItem(IDC_CHECK1))->GetCheck() ) {    // Make it transparent
		m_RadioListBox.ModifyStyle(WS_BORDER,0, 0);
		m_RadioListBox.ModifyStyleEx(WS_EX_CLIENTEDGE,WS_EX_TRANSPARENT,SWP_DRAWFRAME|SWP_FRAMECHANGED);
	} else {   // Draw normally
		m_RadioListBox.ModifyStyle(0,WS_BORDER,0);
		m_RadioListBox.ModifyStyleEx(WS_EX_TRANSPARENT,WS_EX_CLIENTEDGE,SWP_DRAWFRAME|SWP_FRAMECHANGED);
	}
}
